using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using DirectShowLib;
//using QuartzTypeLib;


namespace VMixerDemoNet
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panelPreview;
		private System.Windows.Forms.Button buttonFiles;
		private System.Windows.Forms.Button buttonGraph;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private DirectShowLib.FilterGraph m_objFilterGraph;
		private System.Windows.Forms.RadioButton radioPIP;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.RadioButton radioBoth;
		private System.Windows.Forms.RadioButton radioCut;
		private VIDEOMIXERLib.IVideoMixer m_objVideoMixer;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.panelPreview = new System.Windows.Forms.Panel();
			this.buttonFiles = new System.Windows.Forms.Button();
			this.buttonGraph = new System.Windows.Forms.Button();
			this.radioPIP = new System.Windows.Forms.RadioButton();
			this.radioBoth = new System.Windows.Forms.RadioButton();
			this.radioCut = new System.Windows.Forms.RadioButton();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// panelPreview
			// 
			this.panelPreview.BackColor = System.Drawing.Color.LightSkyBlue;
			this.panelPreview.Location = new System.Drawing.Point(128, 8);
			this.panelPreview.Name = "panelPreview";
			this.panelPreview.Size = new System.Drawing.Size(560, 464);
			this.panelPreview.TabIndex = 0;
			// 
			// buttonFiles
			// 
			this.buttonFiles.Location = new System.Drawing.Point(8, 8);
			this.buttonFiles.Name = "buttonFiles";
			this.buttonFiles.Size = new System.Drawing.Size(112, 23);
			this.buttonFiles.TabIndex = 1;
			this.buttonFiles.Text = "Load Files";
			this.buttonFiles.Click += new System.EventHandler(this.buttonFiles_Click);
			// 
			// buttonGraph
			// 
			this.buttonGraph.Enabled = false;
			this.buttonGraph.Location = new System.Drawing.Point(8, 40);
			this.buttonGraph.Name = "buttonGraph";
			this.buttonGraph.Size = new System.Drawing.Size(112, 23);
			this.buttonGraph.TabIndex = 2;
			this.buttonGraph.Text = "Load Graph";
			this.buttonGraph.Click += new System.EventHandler(this.buttonGraph_Click);
			// 
			// radioPIP
			// 
			this.radioPIP.Checked = true;
			this.radioPIP.Location = new System.Drawing.Point(16, 136);
			this.radioPIP.Name = "radioPIP";
			this.radioPIP.Size = new System.Drawing.Size(80, 24);
			this.radioPIP.TabIndex = 3;
			this.radioPIP.TabStop = true;
			this.radioPIP.Text = "PIP";
			this.radioPIP.CheckedChanged += new System.EventHandler(this.radioPIP_CheckedChanged);
			// 
			// radioBoth
			// 
			this.radioBoth.Location = new System.Drawing.Point(16, 160);
			this.radioBoth.Name = "radioBoth";
			this.radioBoth.Size = new System.Drawing.Size(80, 24);
			this.radioBoth.TabIndex = 4;
			this.radioBoth.Text = "Both";
			this.radioBoth.CheckedChanged += new System.EventHandler(this.radioBoth_CheckedChanged);
			// 
			// radioCut
			// 
			this.radioCut.Location = new System.Drawing.Point(16, 184);
			this.radioCut.Name = "radioCut";
			this.radioCut.Size = new System.Drawing.Size(96, 24);
			this.radioCut.TabIndex = 5;
			this.radioCut.Text = "Split Vertically";
			this.radioCut.CheckedChanged += new System.EventHandler(this.radioCut_CheckedChanged);
			// 
			// label1
			// 
			this.label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.label1.Location = new System.Drawing.Point(8, 112);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(112, 16);
			this.label1.TabIndex = 6;
			this.label1.Text = "View Mode";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(696, 478);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.radioCut);
			this.Controls.Add(this.radioBoth);
			this.Controls.Add(this.radioPIP);
			this.Controls.Add(this.buttonGraph);
			this.Controls.Add(this.buttonFiles);
			this.Controls.Add(this.panelPreview);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "Form1";
			this.Text = "Video Mixer Demo ";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
		}

		private void buttonFiles_Click(object sender, System.EventArgs e)
		{
			// Destroy old graph

			// Create graph objects
			m_objFilterGraph = new DirectShowLib.FilterGraph();

			IGraphBuilder pGraphBuilder = (IGraphBuilder)m_objFilterGraph;

			// Get files names
			String strFirstFile = "";
			String strSecondFile = "";
			OpenFileDialog openFileDialog = new OpenFileDialog();
			if( openFileDialog.ShowDialog() == DialogResult.OK )
			{
				strFirstFile = openFileDialog.FileName;
			}

			if( openFileDialog.ShowDialog() == DialogResult.OK )
			{
				strSecondFile = openFileDialog.FileName;
			}
			else if( strFirstFile == "" )
			{
				return;
			}
		
			// Create Video Mixer
			try
			{
				m_objVideoMixer = new VIDEOMIXERLib.CoVideoMixerClass();
			}
			catch (System.Exception ex)
			{
				MessageBox.Show( this, "Error create MediaLooks Video Mixer filter:\n" + ex.ToString(), "Error" ); 
				return;
			}
			
			// Set 'sync' mode for files
			m_objVideoMixer.SetSyncSources(1);

			// Add Video Mixer to graph and render files
			try
			{
				pGraphBuilder.AddFilter( (IBaseFilter)m_objVideoMixer, "MediaLooks Video Mixer" );
		
				if( strFirstFile != "" ) 
				{
					pGraphBuilder.RenderFile( strFirstFile, null );
				}
				
				if( strSecondFile != "" )
				{
					pGraphBuilder.RenderFile( strSecondFile, null );
				}
			}
			catch (System.Exception ex)
			{
				MessageBox.Show( this, "Error render media files:\n" + ex.ToString(), "Error" ); 
				return;
			}

			// By default first stream is enabled and have 100% alpha 

			// Enable second stream
			m_objVideoMixer.EnableStream( 1 , 1);
			
			// Configure Video Mixer

			// Get output size (by default the first pin input size)
			uint nWidth = 0;
			uint nHeight = 0;
			m_objVideoMixer.GetOutputSize( out nWidth, out nHeight );

			// Set second stream position
			VIDEOMIXERLib.tagRECT srcRect = new VIDEOMIXERLib.tagRECT();
			// Full source rect
			srcRect.left = 0;
			srcRect.right = 0;
			srcRect.top = 0;
			srcRect.bottom = 0;

			VIDEOMIXERLib.tagRECT dstRect = new VIDEOMIXERLib.tagRECT();
			// Full source rect
			dstRect.left = (int)nWidth / 2;
			dstRect.right = (int)nWidth - 16;
			dstRect.top = 16;
			dstRect.bottom = (int)nHeight / 2;

			m_objVideoMixer.SetVideoRects( 1, ref srcRect, ref dstRect );

			// Set second stream alpha (0..255)
			m_objVideoMixer.SetVideoAlpha( 1, 192 );


			// Set video output window
			IVideoWindow pVideoWindow = (IVideoWindow)pGraphBuilder;

			pVideoWindow.put_Owner( panelPreview.Handle );
			pVideoWindow.put_WindowStyle( WindowStyle.Child | WindowStyle.ClipChildren |  WindowStyle.ClipSiblings );
			pVideoWindow.SetWindowPosition( 0, 0, panelPreview.Width, panelPreview.Height );

			// Run graph
			IMediaControl pMediaControl = (IMediaControl)pGraphBuilder;
			pMediaControl.Run();


		}

		private void buttonGraph_Click(object sender, System.EventArgs e)
		{
			// Not implemented yet
		}

		private void radioPIP_CheckedChanged(object sender, System.EventArgs e)
		{
			// Get output size (by default the first pin input size)
			uint nWidth = 0;
			uint nHeight = 0;
			m_objVideoMixer.GetOutputSize( out nWidth, out nHeight );

			// Set second stream position
			VIDEOMIXERLib.tagRECT srcRect = new VIDEOMIXERLib.tagRECT();
			// Zero rect - mean full source rect

			VIDEOMIXERLib.tagRECT dstRect = new VIDEOMIXERLib.tagRECT();
			// Zero rect - mean full output rect

			// First stream postion
			m_objVideoMixer.SetVideoRects( 0, ref srcRect, ref dstRect );

			// Set first stream alpha (0..255)
			m_objVideoMixer.SetVideoAlpha( 1, 255 );

			// PIP rect
			dstRect.left = (int)nWidth / 2;
			dstRect.right = (int)nWidth - 16;
			dstRect.top = 16;
			dstRect.bottom = (int)nHeight / 2;

			m_objVideoMixer.SetVideoRects( 1, ref srcRect, ref dstRect );

			// Set second stream alpha (0..255)
			m_objVideoMixer.SetVideoAlpha( 1, 192 );
		
		}

		private void radioBoth_CheckedChanged(object sender, System.EventArgs e)
		{
			// Get output size (by default the first pin input size)
			uint nWidth = 0;
			uint nHeight = 0;
			m_objVideoMixer.GetOutputSize( out nWidth, out nHeight );

			// Set first stream position
			VIDEOMIXERLib.tagRECT srcRect = new VIDEOMIXERLib.tagRECT();
			// Zero rect - mean full source rect

			VIDEOMIXERLib.tagRECT dstRect = new VIDEOMIXERLib.tagRECT();

            // Set first stream rect (left part of video window)
			dstRect.left = 0;
			dstRect.right = (int)nWidth/2;
			dstRect.top = 0;
			dstRect.bottom = (int)nHeight;
			m_objVideoMixer.SetVideoRects( 0, ref srcRect, ref dstRect );

			// Set first stream alpha (0..255)
			m_objVideoMixer.SetVideoAlpha( 0, 255 );

			// Set second stream rect (right part of video window)
			dstRect.left = (int)nWidth/2;
			dstRect.right = (int)nWidth;
			dstRect.top = 0;
			dstRect.bottom = (int)nHeight;
			m_objVideoMixer.SetVideoRects( 1, ref srcRect, ref dstRect );

			// Set second stream alpha (0..255)
			m_objVideoMixer.SetVideoAlpha( 1, 255 );
		
		}

		private void radioCut_CheckedChanged(object sender, System.EventArgs e)
		{
			// Get first input size
			uint nWidthIn1 = 0;
			uint nHeightIn1 = 0;
			m_objVideoMixer.GetInputSize( 0, ref nWidthIn1, ref nHeightIn1);

			// Get second input size
			uint nWidthIn2 = 0;
			uint nHeightIn2 = 0;
			m_objVideoMixer.GetInputSize( 1, ref nWidthIn2, ref nHeightIn2);

			// Get output size (by default the first pin input size)
			uint nWidth = 0;
			uint nHeight = 0;
			m_objVideoMixer.GetOutputSize( out nWidth, out nHeight );

			

			// Set first stream positon
			VIDEOMIXERLib.tagRECT srcRect = new VIDEOMIXERLib.tagRECT();
			srcRect.left = 0;
			srcRect.right = (int)nWidthIn1/2;
			srcRect.top = 0;
			srcRect.bottom = (int)nHeightIn1;
			VIDEOMIXERLib.tagRECT dstRect = new VIDEOMIXERLib.tagRECT();
			dstRect.left = 0;
			dstRect.right = (int)nWidth/2;
			dstRect.top = 0;
			dstRect.bottom = (int)nHeight;
			m_objVideoMixer.SetVideoRects( 0, ref srcRect, ref dstRect );

			// Set first stream alpha (0..255)
			m_objVideoMixer.SetVideoAlpha( 0, 255 );

			// Set second stream positon
			srcRect.left = (int)nWidthIn2/2;
			srcRect.right = (int)nWidthIn2;
			srcRect.top = 0;
			srcRect.bottom = (int)nHeightIn2;

			// Set second stream rect (right part of video window)
			dstRect.left = (int)nWidth/2;
			dstRect.right = (int)nWidth;
			dstRect.top = 0;
			dstRect.bottom = (int)nHeight;
			m_objVideoMixer.SetVideoRects( 1, ref srcRect, ref dstRect );

			// Set second stream alpha (0..255)
			m_objVideoMixer.SetVideoAlpha( 1, 255 );
		
		}

		
	}
}
